/**
 * @class Ext.ux.SliderTip
 * @extends Ext.Tip
 * Simple plugin for using an Ext.Tip with a slider to show the slider value
 */

Ext.ux.SliderTip = Ext.extend(Ext.Tip, {
  minWidth: 10,
      offsets : [0, -10],
      init : function(slider){
      slider.on("dragstart", this.onSlide, this);
      slider.on("drag", this.onSlide, this);
      slider.on("dragend", this.hide, this);
      slider.on("destroy", this.destroy, this);
      },
      onSlide : function(slider){
      this.show();
      this.body.update(this.getText(slider));
      this.doAutoWidth();
      this.el.alignTo(slider.thumb, "b-t?", this.offsets);
      },
      getText : function(slider){
      return slider.getValue();
      }
  });
var tip = new Ext.ux.SliderTip({
    getText: function(slider){
      return String.format("<b>{0}% complete</b>", slider.getValue());
      }
  });
